from django.db import models
from comics.models import Comic

class ComicStat(models.Model):
    
    comic = models.ForeignKey(Comic, related_name='stats')
    parsed_title = models.CharField(max_length=1500, null=True)
    status = models.IntegerField(null=True)
    protocol = models.CharField(max_length=50, null=True)
    user_agent = models.CharField(max_length=1500, null=True)
    ip = models.CharField(max_length=40, null=True)
    referer = models.CharField(max_length=1500, null=True)
    time = models.DateTimeField()
    path = models.CharField(max_length=1500, null=True)
    method = models.CharField(max_length=10, null=True)
    size = models.IntegerField(null=True)
    timezone = models.CharField(max_length=50, null=True)

class ComicStatCache(models.Model):
    
    comic = models.ForeignKey(Comic)
    date = models.DateField()
    unique = models.IntegerField()
    views = models.IntegerField()
    returns = models.IntegerField(null=True, blank=True)

class ComicStatTrafficSources(models.Model):
    comic = models.ForeignKey(Comic)
    url = models.CharField(max_length=1500)
