from django.http import HttpResponse, HttpResponseNotFound
from django.shortcuts import render


from analytics.models import ComicStat
from comics.models import Comic, ComicPage
from comments.models import Comment


def comic_stats(request, slug):
    try:
        comic = Comic.objects.get(slug=slug)
    except Comic.DoesNotExist:
        return HttpResponseNotFound()
    if not comic.user == request.user and not request.user.is_staff:
        return HttpResponseNotFound()

    hits = ComicStat.objects.filter(comic=comic).count()
    pages = ComicPage.objects.filter(is_deleted=False)
#    comment_count = 0
#    for page in pages:
#        comment_count += page.comments.filter(is_deleted=False).count()
#    average_comment_count = int(comment_count / pages.count())
    
    variables = {
        'comic':comic,
        'hits': hits,
#        'comment_count': comment_count,
#        'average_comment_count': average_comment_count,
    }
    return render(request, 'analytics/comic_stats.html', variables)
