#!/usr/bin/env python
from django.core.management import setup_environ
import settings
setup_environ(settings)


from datetime import date
import log_reader


from analytics.models import ComicStat
from comics.models import Comic


def cycle_log_file():
    return


def determine_comic(path):
    try:
        path = path.split('/')
        if path[0] == '':
            comic_slug = path[1]
        else:
            comic_slug = path[0]

        print 'comic_path:', path
        print 'comic_slug:', comic_slug

        comic = Comic.objects.get(slug=comic_slug)
        return comic
    except Comic.DoesNotExist:
        return False


def process_record(record):
    try:
        if '.' in record['path']:
            return False
        print record['path']
        comic = determine_comic(record['path'])
    except KeyError:
        return False

    if not comic:
        return False

    print 'processing', comic.title

    try:
        stat = ComicStat.objects.create(
            comic=comic,
            parsed_title=comic.title,
            status=record.get('status', ''),
            protocol=record.get('protocol', ''),
            user_agent=record.get('user-agent', ''),
            ip=record.get('ips', [''])[0],
            referer=record.get('referer', ''),
            time=record.get('time', ''),
            path=record.get('path', ''),
            method=record.get('method', ''),
            size=record.get('size', ''),
            timezone=record.get('tz', '')
        )
    except ValueError:
        print '!!!!!!!!!!!!!!!!!!!!!! VALUE ERROR @', comic.title, record['path']

    #print stat

    return


def main(log_file='access.log'):

    log_file = open(log_file, 'r')
    reader = log_reader.ApacheReader(log_file)
    reader.next()

    counter = 0

    try:
#        records = [process_record(record) for record in reader]
        for record in reader:
            counter += 1
            print counter
            try:
                process_record(record)
            except ValueError:
                print '$$$$$$$$$$$$$$$$$$$$$$$$$ VALUE ERROR'#, record
        log_file.close()
    except KeyError:
        print 'key error'
        log_file.close()

    return



if __name__ == '__main__':
    import sys
    main(sys.argv[1])
    cycle_log_file()
