from django.http import HttpResponse
from django.template import response
from comics.models import *
from news.models import *
from datetime import datetime
from podcasts.models import Episode
from django.core import serializers
from django.utils import simplejson

json_serializer = serializers.get_serializer("json")()

def api_latestnews(request):

	# Featured news
    news = Article.objects.filter(urgent=False, is_live=True, date_live__lte=datetime.now()).order_by("-date_live")[:20]
    data = json_serializer.serialize(news, ensure_ascii=False, fields=('title','slug','date_live','date_added','date_modified'))

    return HttpResponse(simplejson.dumps(data), content_type='application/json; charset=utf8', mimetype='application/json')

def api_featuredcomics(request):

    serializer = serializers.get_serializer("json")()

    # Featured comics
    comics = FeaturedComic.objects.filter(comic__is_deleted=False, date_featured__lte=datetime.now()).order_by('-date_featured')[:10]
    data = serializer.serialize(comics, ensure_ascii=False, fields=('comic','title','thumbnail','date_featured'), use_natural_keys=True)

    return HttpResponse(simplejson.dumps(data), content_type='application/json; charset=utf8;', mimetype='application/json')

def api_toptencomics(request):

    # Select top ten comics
    topten = Comic.live.order_by('-seven_day_visits')[:20]
    data = json_serializer.serialize(topten, ensure_ascii=False)

    return HttpResponse(simplejson.dumps(data), content_type='application/json; charset=utf8', mimetype='application/json')

def api_quackcastepisodes(request):

    episodes = Episode.live.all()[:10]
    data = json_serializer.serialize(episodes, ensure_ascii=False, fields=('title','slug','date_live','url'))

    return HttpResponse(simplejson.dumps(data), mimetype='application/json')