from django.contrib import admin
from comics.models import *


def soft_delete(modeladmin, request, queryset):
    queryset.update(is_deleted=True)
    
import pymysql
import hashlib
from images import *
from django.utils.encoding import smart_str

def reimport_images(modeladmin, request, queryset):
    db = pymysql.connect(host='97.74.200.99', user='drunkduck', passwd='ice22hdi5m', db='drunkduck')
    for comic in queryset:
        print comic.title
        cur = db.cursor()
        sql = "select comic_id from comics where comic_name = '%s'" % comic.title
        cur.execute(sql)
        comic_id = None
        for r in cur:
            comic_id = int(r[0])
        cur.close()
        i = 0
        count = comic.pages.filter(old_page_id__isnull=False).count()
        for page in comic.pages.filter(old_page_id__isnull=False).order_by('title'):
            i = i + 1
            if not page.file_ext or page.file_ext == 'swf':
                print "%s of %s - SKIPPED!" % (i, count)
                continue
            new_path = "users/%s/comics/%s/web/%s.%s" % (comic.user.username, comic.slug, str(page.old_page_id).zfill(8), page.file_ext)
            m = hashlib.md5()
            m.update(str(comic_id))
            m.update(str(page.old_page_id))
            filename = m.hexdigest()
            old_path = "http://original.drunkduck.com/%s/pages/%s.%s" % (comic.slug, filename, page.file_ext)
            try:
                image = load_image_from_url(old_path)
                image, resized = rescale(image, 960)
                upload_image(image, new_path, page.file_ext)
            except:
                continue
            page.content = new_path
            page.save()
            print "%s of %s - %s" % (i, count, smart_str(page.title))


class ComicAdmin(admin.ModelAdmin):
    
    list_display = ('title', 
        'user',
        'date_created', 
        'date_modified', 
        'rating',
        'type',
        'genre',
        'tone',
        'style',
        'frozen',
        'seven_day_visits'
    )
    exclude = ('user','assistants','favorites','recommends','likes','email_alerts','duckmarks',)
    search_fields = ['user__username', 'title']
    prepopulated_fields = {"slug":('title',)}
    list_filter = [
        'rating',
        'type',
        'genre',
        'tone',
        'style',
        'frozen'
    ]
    actions = [
        soft_delete,
        reimport_images
    ]
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.user:
            instance.user = request.user
        instance.save()
        return instance

admin.site.register(Comic, ComicAdmin)

class FeaturedComicAdmin(admin.ModelAdmin):
    
    list_display = ('comic',)
    search_fields = ['comic__title', 'comic__user__username']
    
admin.site.register(FeaturedComic, FeaturedComicAdmin)

class PageAdmin(admin.ModelAdmin):
    
    list_display = ('comic', 'title', 'post_date', 'order_id',)
    search_fields = ['comic__title', 'comic__user__username']
    exclude = ('comments','old_page_id',)
    
admin.site.register(ComicPage, PageAdmin)

class ComicLinkAdmin(admin.ModelAdmin):
    
    list_display = ('comic', 'name',)
    search_fields = ['comic__title', 'comic__user__username', 'name']
    
admin.site.register(ComicLink, ComicLinkAdmin)