from datetime import datetime
from django.contrib.syndication.views import Feed
from django.shortcuts import get_object_or_404
from comics.models import *

class ComicFeed(Feed):
    
    def get_object(self, request, slug):
        
        return get_object_or_404(Comic, slug=slug)

    def title(self, obj):
        
        return obj.title

    def link(self, obj):
        
        return "http://www.theduckwebcomics.com/%s/" % obj.title

    def description(self, obj):
        
        return "Latest updates for this comic."

    def items(self, obj):
        
        return obj.pages.filter(is_deleted=False, post_date__lte=datetime.now()).order_by('-post_date')[:5]
    
    def item_title(self, item):
        
        return item.title
    
    def item_description(self, item):
        
        return item.comment
    
    def item_link(self, item):
        
        return "http://www.theduckwebcomics.com/%s/%s/" % (item.comic.slug, item.id)
    
    def item_pubdate(self, item):
        
        return item.post_date
