from django import forms
from comics.models import *
from django.forms import RadioSelect, CheckboxSelectMultiple
from django.forms.extras.widgets import SelectDateWidget
from tinymce.widgets import TinyMCE

class ComicForm(forms.ModelForm):

    class Meta:
        fields = (
            'title',
            'description',
            'type', 
            'tone',
            'genre',
            'style',
            'rating',
            'thumbnail',
            'header',
            'enable_forums',
            'enable_homepage',
        )

        model = Comic
        widgets = {
            'type': RadioSelect,
            'genre': RadioSelect,
            'tone': RadioSelect,
            'style': RadioSelect,
            'rating': RadioSelect,
        }
    
class ComicEditForm(forms.ModelForm):

    class Meta:
        fields = (
            'description',
            'type', 
            'tone',
            'genre',
            'style',
            'rating',
            'thumbnail',
            'header',
            'enable_forums',
            'enable_homepage',
        )

        model = Comic
        widgets = {
            'type': RadioSelect,
            'genre': RadioSelect,
            'tone': RadioSelect,
            'style': RadioSelect,
            'rating': RadioSelect,
        }

YEAR_CHOICES = ('2002','2003','2004','2005','2006','2007','2008','2009','2010','2011','2012','2013','2014','2015')
    
class PageForm(forms.ModelForm):

    class Meta:
        
        model = ComicPage
        fields = (
            'post_date',
            'title',
            'comment',
            'content',
            'is_chapter'
        )
        widgets = {
            'post_date': SelectDateWidget(years=YEAR_CHOICES),
            'comment': TinyMCE(),
            'content': forms.FileInput(),
        }
        
class LinkForm(forms.ModelForm):

    class Meta:
        
        model = ComicLink
        exclude = ('comic',)
