from django import template
from datetime import datetime
from settings import MEDIA_URL
from users.templatetags.user_tags import can_see_comic

register = template.Library()

@register.filter
def get_page_count(comic):
    return comic.pages.filter(post_date__lte=datetime.now(), is_deleted=False).count()

@register.filter
def thumbnail(object, user):
    try:
        comic = object.comic
    except:
        comic = object
    if not can_see_comic(user, comic):
        url = MEDIA_URL + 'images/avatar-generic-comic-A.png'
    elif object.thumbnail:
        url = object.thumbnail.url
    else:
        url = MEDIA_URL + 'images/avatar-generic-comic.png'
    return url