from django.contrib import admin
from forums.models import *

class ForumAdmin(admin.ModelAdmin):
    
    list_display = ('title', 'category', 'date_added', 'user', 'comic',)
    search_fields = ['title', 'user__username', 'comic__title']
    exclude = ('user','comic',)
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.user:
            instance.user = request.user
        instance.save()
        return instance

admin.site.register(Forum, ForumAdmin)

class TopicAdmin(admin.ModelAdmin):
    
    list_display = ('title', 'forum', 'date_added', 'user',)
    exclude = ('user',)
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.user:
            instance.user = request.user
        instance.save()
        return instance

admin.site.register(Topic, TopicAdmin)

class PostAdmin(admin.ModelAdmin):
    
    list_display = ('user', 'topic', 'date_added',)
    exclude = ('user',)
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.user:
            instance.user = request.user
        instance.save()
        return instance

admin.site.register(Post, PostAdmin)

class SignatureAdmin(admin.ModelAdmin):
    
    list_display = ('user',)
    
admin.site.register(Signature, SignatureAdmin)