from django import forms
from forums.models import *
from tinymce.widgets import TinyMCE

class TopicForm(forms.ModelForm):
    
    class Meta:
        
        model = Topic
        exclude = ('user', 'forum', 'date_modified')   

class PostForm(forms.ModelForm):
    
    body = forms.CharField(widget=TinyMCE())
    
    class Meta:
        
        model = Post
        exclude = ('user', 'topic', 'date_modified')
        
    def clean_body(self):
        
        if 'body' in self.data:
            body = self.data['body']
            body = body.strip()
            if not body == '' and not body == '&nbsp;':
                return self.data['body']
        raise forms.ValidationError('You can\'t post with no message.')
        
class ForumForm(forms.ModelForm):
    
    description = forms.CharField(required=False, widget=TinyMCE(attrs={'cols': 75, 'rows': 20}))
    
    class Meta:
        
        model = Forum
        exclude = ('comic', 'moderators', 'is_deleted', 'user',)
        
class SignatureForm(forms.ModelForm):
    
    body = forms.CharField(widget=TinyMCE())
    
    class Meta:
        
        model = Signature
        exclude = ('user',)
