from django import template
from forums.models import *
from django.utils.safestring import mark_safe

register = template.Library()

@register.filter
def post_count(forum_or_topic):
    if isinstance(forum_or_topic, Forum):
        return Post.objects.filter(topic__forum=forum_or_topic, is_deleted=False).count()
    return forum_or_topic.posts.filter(is_deleted=False).count()

@register.filter
def latest_post(forum_or_topic):
    if isinstance(forum_or_topic, Forum):
        latest_post = Post.objects.filter(topic__forum=forum_or_topic, is_deleted=False).order_by('-date_added')[:1]
    else:
        latest_post = forum_or_topic.posts.filter(is_deleted=False).order_by('-date_added')[:1]
    if latest_post:
        return latest_post[0]
    return False

@register.filter
def post_page(post, items_per_page=30):
    posts = list(post.topic.posts.all())
    count = len(posts)
    index = posts.index(post)
    if index == 0:
        page = 1
    else:
        page = count / items_per_page
        if count % items_per_page:
            page += 1
    return page

@register.filter
def topic_pages(topic, items_per_page=30):
    count = topic.posts.filter(is_deleted=False).count()
    pages = count / items_per_page
    if count % items_per_page:
        pages += 1
    return pages

@register.filter
def stripquotes(string):
#    print 'old string: ' + string
#    p = re.compile(r"\[quote=?\"?[a-zA-Z\s\d]*\"?\].*\[\/quote\]")
#    matches = p.findall(string)
#    if matches:
#        for match in matches:
#            string = string.replace(match, '')
##    p = re.compile('<blockquote>.*</blockquote>')
##    matches = p.findall(string)
##    if matches:
##        for match in matches:
#    print 'new string: ' + string
    return string