"""
#########################################################################
POST IMAGE HANDLERS
#########################################################################
"""

import settings

def image_upload(instance, filename):
    return "%s%s/assets/%s" % (settings.AWS_ROOT, instance.user.username, filename)

"""
#########################################################################
MODELS
#########################################################################
"""

from django.db import models
from django.contrib.auth.models import User

class ImageFile(models.Model):
    user = models.ForeignKey(User, related_name='imagefiles')
    image = models.ImageField(upload_to=image_upload)
    date_modified = models.DateTimeField(auto_now=True)
    date_uploaded = models.DateTimeField(auto_now_add=True)