"""
#########################################################################
FORMS
#########################################################################
"""

from django import forms
from layouts.models import Layout

class LayoutBackgroundForm(forms.ModelForm):

    class Meta:
        
        model = Layout
        fields = (
            'background_image', 
            'background_color',
            'background_repeat',
            'background_position',
            'background_fixed',
        )
        
class LayoutPageForm(forms.ModelForm):
    
    class Meta:
        
        model = Layout
        fields = (
            'page_border_color',
            'page_border_size',
            'header_color',
            'header_bold',
            'header_italic', 
            'text_color',
            'text_size',
            'text_bold',
            'text_italic',
            'link_color',
            'link_decoration',
            'link_hover_color',
            'link_hover_decoration',
        )
        
class LayoutNavForm(forms.ModelForm):
    
    class Meta:
        
        model = Layout
        fields = (
            'arrow_first',
            'arrow_prev',
            'arrow_next',
            'arrow_last',
            'nav_position',
        )
        
class LayoutAuthorForm(forms.ModelForm):
    
    class Meta:
        
        model = Layout
        fields = (
            'author_background_color',
            'author_header_color',
            'author_header_bold',
            'author_header_italic', 
            'author_text_color',
            'author_text_size',
            'author_text_bold',
            'author_text_italic',
            'author_link_color',
            'author_link_decoration',
            'author_link_hover_color',
            'author_link_hover_decoration',
        )
        
class LayoutCommentForm(forms.ModelForm):
    
    class Meta:
        
        model = Layout
        fields = (
            'comment_background_color',
            'comment_header_color',
            'comment_header_bold',
            'comment_header_italic', 
            'comment_text_color',
            'comment_text_size',
            'comment_text_bold',
            'comment_text_italic',
            'comment_link_color',
            'comment_link_decoration',
            'comment_link_hover_color',
            'comment_link_hover_decoration',
        )