"""
#########################################################################
VIEWS
#########################################################################
"""

from django.contrib.auth.decorators import login_required
from django.shortcuts import get_object_or_404, HttpResponse
from comics.models import Comic
from layouts.forms import *
from layouts.models import Layout

@login_required
def background(request, id):
    
    if request.is_ajax():
        comic = get_object_or_404(Comic, is_deleted=False, pk=id)
        try:
            layout = comic.layout
        except:
            layout = Layout.objects.create(comic=comic)
        form = LayoutBackgroundForm(request.POST, instance=layout)
        if form.is_valid():
            form.save()
        else:
            print form.errors
    return HttpResponse()   

@login_required
def page(request, id):
    
    if request.is_ajax():
        comic = get_object_or_404(Comic, is_deleted=False, pk=id)
        try:
            layout = comic.layout
        except:
            layout = Layout.objects.create(comic=comic)
        form = LayoutPageForm(request.POST, instance=layout)
        if form.is_valid():
            form.save()
        else:
            print form.errors
    return HttpResponse()    

@login_required
def author(request, id):
    
    if request.is_ajax():
        comic = get_object_or_404(Comic, is_deleted=False, pk=id)
        try:
            layout = comic.layout
        except:
            layout = Layout.objects.create(comic=comic)
        form = LayoutAuthorForm(request.POST, instance=layout)
        if form.is_valid():
            form.save()
        else:
            print form.errors
    return HttpResponse()    

@login_required
def nav(request, id):
    
    if request.is_ajax():
        comic = get_object_or_404(Comic, is_deleted=False, pk=id)
        try:
            layout = comic.layout
        except:
            layout = Layout.objects.create(comic=comic)
        form = LayoutNavForm(request.POST, instance=layout)
        if form.is_valid():
            form.save()
        else:
            print form.errors
    return HttpResponse()  

@login_required
def comment(request, id):
    
    if request.is_ajax():
        comic = get_object_or_404(Comic, is_deleted=False, pk=id)
        try:
            layout = comic.layout
        except:
            layout = Layout.objects.create(comic=comic)
        form = LayoutCommentForm(request.POST, instance=layout)
        if form.is_valid():
            form.save()
        else:
            print form.errors
    return HttpResponse()    
