from django import forms
from django.contrib.auth.models import User

class MessageForm(forms.Form):
    
    to = forms.CharField(label='to')
    subject = forms.CharField(label='subject', max_length=100)
    body = forms.CharField(label='message', widget=forms.Textarea())
    
    def clean_to(self):
        to = self.data['to'].strip()
        try:
            user = User.objects.get(username__iexact=to)
            return user.username
        except:
            pass
        raise forms.ValidationError('There is no user by that name.')
    
class ReplyForm(forms.Form):
    
    body = forms.CharField(label='reply', widget=forms.Textarea())
