#! /usr/bin/env python
from django.core.management import setup_environ
import settings
setup_environ(settings)

import os
import hashlib
import pymysql
import sys
import traceback
import fileinput
import time
if settings.hostname == 'drunkduck':
    import psycopg2
from django.contrib.auth.models import User
from django.utils.encoding import smart_str
from images import *
from forums.models import *
from podcasts.models import *
from news.models import *
from comics.models import *
from comments.models import *
from forums.models import *
from users.models import *
from tutorials.models import *
from ratings.models import *
from requests.models import *
from django.core.mail import send_mail
from messages.models import *
from analytics.models import *

class Suite:
    
    def __init__(self):
    
        self.db = pymysql.connect(host='97.74.200.99', user='drunkduck', passwd='ice22hdi5m', db='drunkduck')
        self.db_forums = pymysql.connect(host='97.74.200.99', user='drunkduck', passwd='ice22hdi5m', db='drunkduck_community')
        if settings.hostname == 'drunkduck':
            self.db_podcast = psycopg2.connect(user="dd_podcast", database="drunkduck_podcast", host="192.168.167.22", password="G00dduck.11")

    def close(self):
        
        self.db.close()
        self.db_forums.close()
        
    def get_cursor(self):
        
        return self.db.cursor()
    
    def get_forums_cursor(self):
        
        return self.db_forums.cursor()
    
    def get_podcast_cursor(self):
        
        return self.db_podcast.cursor()
    
    def begin(self):
        
        if 'help' in sys.argv:
            print
            print 'The following data is available for importing:'
            print 'users'
            print 'friends'
            print 'comics'
            print 'pages'
            print 'comments'
            print 'news'
            print 'forums'
            print 'featured (featured comics)'
            print 'tutorials'
            print 'favorites (comic favorites, email alerts and recommends)'
            print 'credits'
            print 'bannedips'
            print 'quackcast'
            print 'quacks'
            print 'stats'
            print 'images [--image-type (featuredimages, avatars, thumbnails, pageimages)] [--image-letter (a letter)]'
            print
        else:
            if 'users' in sys.argv:
                self.import_users()
            if 'friends' in sys.argv:
                self.import_friends()
            if 'comics' in sys.argv:
                self.import_comics()
            if 'pages' in sys.argv:
                self.import_pages()
            if 'comments' in sys.argv:
                self.import_profile_comments()
#                self.import_page_comments()
            if 'news' in sys.argv:
                self.import_news()
            if 'quacks' in sys.argv:
                self.import_quacks()
            if 'forums' in sys.argv:
                self.import_forums()
            if 'topics' in sys.argv:
                self.import_topics()
            if 'posts' in sys.argv:
                self.import_posts()
            if 'featured' in sys.argv:
                self.import_comics_featured()
            if 'tutorials' in sys.argv:
                self.import_tutorials()
            if 'favorites' in sys.argv:
                self.import_favorites()
            if 'credits' in sys.argv:
                self.import_credits()
            if 'images' in sys.argv:
                self.import_images()
            if 'bannedips' in sys.argv:
                self.import_banned_ips()
            if 'stats' in sys.argv:
                self.import_stats()
            if 'quackcast' in sys.argv:
                if settings.hostname == 'drunkduck':
                    self.import_quackcasts()
                else:
                    print 'must be on the live server to migrate quackcasts...'
            print
            print 'DONE'
            print
            if settings.hostname == 'drunkduck':
                send_mail('Import complete', 'The import completed with no errors. arguments: ' + ', '.join(sys.argv), 'support@drunkduck.com', ['lleach@wowio.com', 'danielkram@gmail.com'])
        self.close()
        
    def import_stats(self):
        
        print
        print 'IMPORTING STATS...'
        print
        for comic in Comic.objects.order_by('title'):
            print comic.title
            if comic.stats.count() > 0:
                continue
            cur = self.get_cursor()
            sql = "select s.ymd_date, s.counter, s.multiplier from comic_pageviews s left join comics c on c.comic_id = s.comic_id where c.comic_name = '%s'" % comic.title
            cur.execute(sql)
            for r in cur:
                time = str(r[0])
                time = time[0] + time[1] + time[2] + time[3] + '-' + time[4] + time[5] + '-' + time[6] + time[7] + ' 00:00:00'
                print '  ' + time
                counter = int(r[1])
                multiplier = int(r[2])
                iterations = counter * multiplier
                for i in xrange(iterations):
                    ComicStat.objects.create(comic=comic, time=time)
                    print '    ' + str(i)
            cur.close()
        
    def import_quacks(self):
        
        print
        print 'IMPORTING QUACKS...'
        print
        for user in User.objects.order_by('username'):
            print user.username
            user.inbox.all().delete()
            cur = self.get_cursor()
            sql = "select mail_id as id, username_to as recipient, username_from as sender, title, message, from_unixtime(time_sent) as date_sent, viewed as `read` from mailbox where title is not null and message is not null and username_to = '%s' and username_from is not null order by mail_id desc" % user.username
            cur.execute(sql)
            for r in cur:
                try:
                    sender = User.objects.get(username=r[2])
                except:
                    continue
                message = Message.objects.create(
                    recipient=user,
                    sender=sender,
                    subject=smart_str(r[3]),
                    body=smart_str(r[4]),
                    read=bool(int(r[6]))
                )
                message.date_sent = r[5]
                message.parent_id = message.id
                message.save()
                print '  ' + str(r[0])
            cur.close()
        
    def import_banned_ips(self):
        
        print
        print 'IMPORTING BANNED IPS...'
        print
        for line in fileinput.input("banned_ips.txt"):
            line = line.strip()
            ip, date = line.split(',')
            print 'banning: ' + ip
            date = time.localtime(float(date))
            date = time.strftime("%Y-%m-%d %H:%M:%S", date)
            ipban = IPBan.objects.create(ip_address=ip)
            ipban.date_banned = date
            ipban.save()
        
    def import_quackcasts(self):
        
        print
        print 'IMPORTING QUACKCASTS...'
        print
        print 'REMOVING OLD QUACKCASTS...'
        print
        Episode.objects.all().delete()
        cur = self.get_podcast_cursor()
        sql = "select isactive as is_live, title, path as url, leadin as summary, detail as notes, slug, pub_date as date_added from podcast_podcast"
        user = User.objects.get(username='dankram')
        cur.execute(sql)
        for r in cur:
            print 'importing episode: ' + r[1]
            episode = Episode.objects.create(user=user, title=r[1], is_live=r[0], url=r[2], summary=r[3], notes=r[4], slug=r[5], date_live=r[6])
            episode.date_added = r[6]
            episode.save()
        cur.close()
                
    def import_images(self):
        
#        if '--image-type' in sys.argv:
#            index = sys.argv.index('--image-type')
#            type = sys.argv[index+1]
#            if type == 'featuredimages':
#                self.import_comics_featured_thumbnails()
#            elif type == 'avatars':
#                self.import_user_avatars()
#            elif type == 'thumbnails':
#                self.import_comic_thumbnails()
#            elif type == 'pageimages':
#                self.import_page_images()
#        else:
#            self.import_comics_featured_thumbnails()
#            self.import_user_avatars()
#            self.import_comic_thumbnails()
            self.import_page_images()
        
    def import_comics_featured_thumbnails(self):
        
        letter = ''
        if '--image-letter' in sys.argv:
            index = sys.argv.index('--image-letter')
            letter = sys.argv[index+1]
            letter = ' and c.comic_name like "' + letter + '%"'
        print
        print 'IMPORTING FEATURED COMIC THUMBNAILS...'
        print
        cur = self.get_cursor()
        sql = "select c.comic_name, f.feature_id from featured_comics f left join comics c on c.comic_id = f.comic_id where c.comic_name is not null" + letter + " order by c.comic_name"
        cur.execute(sql)
        for r in cur:
            print r[0]
            new_path = 'features/' + r[0].replace(' ', '_') + '/thumb/featured.jpg'
            if os.path.exists('media/' + new_path):
                continue
            old_path = 'http://www.drunkduck.com/gfx/featured_comic_gfx/' + str(r[1]) + '.gif'
            try:
                image = load_image_from_url(old_path)
                image, resized = rescale(image, 105, 160, True)
                upload_image(image, new_path, 'jpg')
            except:
                traceback.print_exc()
        cur.close()
    
    def import_user_avatars(self):
        
        letter = ''
        if '--image-letter' in sys.argv:
            index = sys.argv.index('--image-letter')
            letter = sys.argv[index+1]
            letter = ' and username like "' + letter + '%"'
        print
        print 'IMPORTING USER AVATARS...'
        print
        cur = self.get_cursor()
        sql = "select username, avatar_ext, user_id from users where username is not null and avatar_ext is not null and (~flags & 4096 = 4096)" + letter + " order by username asc"
        cur.execute(sql)
        for r in cur:
            print r[0]
            new_path = 'users/' + r[0] + '/thumb/avatar.' + str(r[1])
            if os.path.exists('media/' + new_path):
                continue
            old_path = 'http://www.drunkduck.com/gfx/avatars/avatar_' + str(r[2]) + '.' + str(r[1])
            try:
                image = load_image_from_url(old_path)
                image, resized = rescale(image, 100, 100)
                upload_image(image, new_path, str(r[1]))
            except:
                traceback.print_exc()
        cur.close()
            
    def import_comic_thumbnails(self):
        
        letter = ''
        if '--image-letter' in sys.argv:
            index = sys.argv.index('--image-letter')
            letter = sys.argv[index+1]
            letter = ' and c.comic_name like "' + letter + '%"'
        print
        print 'IMPORTING COMIC THUMBNAILS...'
        print
        cur = self.get_cursor()
        sql = "select u.username, c.comic_name from comics c left join users u on u.user_id = c.user_id where c.comic_name is not null and u.username is not null and (~u.flags & 4096 = 4096)" + letter + " order by c.comic_name"
        cur.execute(sql)
        for r in cur:
            image = None
            print r[1]
            comic = r[1].replace(' ', '_')
            new_path = 'users/' + r[0] + '/comics/' + comic + '/thumb/thumb.jpg'
            if os.path.exists('media/' + new_path):
                continue
            old_path = 'http://www.drunkduck.com/comics/' + comic[0] + '/' + comic + '/gfx/thumb.'
            for format in IMAGE_FORMATS:
                try:
                    image = load_image_from_url(old_path + format)
                    image, resized = rescale(image, 80, 100, True)
                    upload_image(image, new_path, 'jpg')
                    break
                except:
                    traceback.print_exc()
                    continue
        cur.close()
            
    def import_page_images(self):
        
#        if '--comic' in sys.argv:
#            index = sys.argv.index('--comic')
#            comic_name = str(sys.argv[index+1]).replace('_', ' ')
#        else:
#            return
#        print
#        print 'IMPORTING COMIC PAGE IMAGES...'
#        print
#        try:
#            comic = Comic.objects.get(title__iexact=comic_name)
#        except:
#            return
#        cur = self.get_cursor()
#        sql = "select comic_id from comics where comic_name = '%s'" % comic.title
#        cur.execute(sql)
#        comic_id = None
#        for r in cur:
#            comic_id = int(r[0])
#        cur.close()
#        for page in comic.pages.order_by('title'):
#            if page.file_ext == 'swf':
#                continue
#            if not page.file_ext:
#                continue
#            new_path = "users/%s/comics/%s/web/%s.%s" % (comic.user.username, comic.slug, str(page.old_page_id).zfill(8), page.file_ext)
#            m = hashlib.md5()
#            m.update(str(comic_id))
#            m.update(str(page.old_page_id))
#            filename = m.hexdigest()
#            old_path = "http://original.drunkduck.com/%s/pages/%s.%s" % (comic.slug, filename, page.file_ext)
#            try:
#                image = load_image_from_url(old_path)
#                image, resized = rescale(image, 960)
#                upload_image(image, new_path, page.file_ext)
#            except:
#                continue
#            page.content = new_path
#            page.save()
#            print smart_str(page.title)
            
        print
        print 'IMPORTING COMIC PAGE IMAGES...'
        print
        x = 5
        for comic in Comic.objects.order_by('-seven_day_visits')[5:200]:
            x = x + 1
            print "%s - %s" % (x, comic.title)
            cur = self.get_cursor()
            sql = "select comic_id from comics where comic_name = '%s'" % comic.title
            cur.execute(sql)
            comic_id = None
            for r in cur:
                comic_id = int(r[0])
            cur.close()
            i = 0
            count = comic.pages.filter(old_page_id__isnull=False).count()
            for page in comic.pages.filter(old_page_id__isnull=False).order_by('title'):
                i = i + 1
                if not page.file_ext or page.file_ext == 'swf':
                    print "%s of %s - SKIPPED!" % (i, count)
                    continue
                new_path = "users/%s/comics/%s/web/%s.%s" % (comic.user.username, comic.slug, str(page.old_page_id).zfill(8), page.file_ext)
                m = hashlib.md5()
                m.update(str(comic_id))
                m.update(str(page.old_page_id))
                filename = m.hexdigest()
                old_path = "http://original.drunkduck.com/%s/pages/%s.%s" % (comic.slug, filename, page.file_ext)
                try:
                    image = load_image_from_url(old_path)
                    image, resized = rescale(image, 960)
                    upload_image(image, new_path, page.file_ext)
                except:
                    continue
                page.content = new_path
                page.save()
                print "%s of %s - %s" % (i, count, smart_str(page.title))
        
    def import_tutorials(self):
        
        print
        print 'IMPORTING TUTORIALS...'
        print
        print 'REMOVING OLD TUTORIALS...'
        print
        Tutorial.objects.all().delete()
        cur = self.get_cursor()
        sql = 'select tutorial_id as id, username, from_unixtime(timestamp) as date_added, title, body, description from tutorials where title is not null and body is not null and description is not null order by title'
        cur.execute(sql)
        for r in cur:
            try:
                user = User.objects.get(username=r[1])
            except:
                continue
            print smart_str(r[3])
            print '  importing data'
            tutorial = Tutorial.objects.create(user=user, title=smart_str(r[3]), description=r[5])
            tutorial.body = self.change_tutorial_urls(smart_str(r[4]))
            tutorial.date_added = r[2]
            tutorial.save()
            self.import_tutorial_ratings(tutorial, r[0])
            self.import_tutorial_tags(tutorial, r[0])
        cur.close()
        
    def change_tutorial_urls(self, body):
        
        body = body.replace('http://www.drunkduck.com/gfx/', 'http://media.drunkduck.com/')
        body = body.replace('http://images.drunkduck.com/', 'http://media.drunkduck.com/')
        return body
    
    def import_tutorial_ratings(self, tutorial, old_id):
        
        print '  importing ratings'
        cur = self.get_cursor()
        sql = 'select v.rating, u.username from tutorial_votes v left join users u on u.user_id = v.user_id where tutorial_id = ' + str(old_id)
        cur.execute(sql)
        for r in cur:
            user = User.objects.filter(username=r[1])
            if user:
                user = user[0]
                rating = Rating.objects.create(user=user, rating=int(r[0]))
                tutorial.ratings.add(rating)
        cur.close()
        
    def import_tutorial_tags(self, tutorial, old_id):
        
        print '  importing tags'
        cur = self.get_cursor()
        sql = 'select tag from tutorial_tags where tutorial_id = ' + str(old_id) + ' group by tag'
        cur.execute(sql)
        array = []
        for r in cur:
            tag = str(r[0]).strip().lower()
            array.append(tag)
        cur.close()
        tags = ' '.join(array)
        tutorial.tags = tags
        tutorial.save()
        
    def import_forums(self):
        
        print
        print 'IMPORTING COMIC FORUMS'
        print
        
        for forum in Forum.objects.filter(user__isnull=True).order_by('-id'):
            print str(forum.id)
            try:
                user = forum.comic.user
            except:
                continue
            forum.user = user
            forum.save()
            
            
#        cur = self.get_forums_cursor()
#        sql = "select ca.category_id as id, ca.category_name as title, ca.category_desc as description, ca.order_id as `order`, c.comic_name from community_categories ca left join drunkduck.comics c on c.comic_id = ca.comic_id where c.comic_name is not null order by ca.category_id desc"
#        cur.execute(sql)
#        for r in cur:
#            try:
#                comic = Comic.objects.get(title=r[4])
#            except:
#                continue
#            forum, created = Forum.objects.get_or_create(comic=comic, old_id=int(r[0]))
#            if created:
#                print str(r[0])
#                forum.title = smart_str(r[1])
#                forum.description = smart_str(r[2])
#                forum.order = int(r[3])
#                forum.save()
#        cur.close()
        
#        for topic in Topic.objects.filter(forum__comic__isnull=False).order_by('-id'):
#            try:
#                post = topic.posts.order_by('-date_added')[:1][0]
#            except:
#                continue
#            topic.date_modified = post.date_added
#            topic.save()
#            print "%s - %s - %s" % (str(topic.id), str(post.date_added), str(topic.date_modified))
            
#        print 'FIXING USER ENABLE FORUMS'
#        for forum in Forum.objects.filter(comic__isnull=False):
#            comic = forum.comic
#            if not comic.enable_forums:
#                comic.enable_forums = True
#                comic.save()
#                print comic.title
        
#        cur = self.get_forums_cursor()
#        sql = "select ca.category_id as id, ca.grouping as category, ca.category_name as title, ca.category_desc as description, ca.order_id as `order`, if(ca.flags & 1, 1, if(ca.flags & 2, 1, 0)) as is_private, c.comic_name from community_categories ca left join drunkduck.comics c on c.comic_id = ca.comic_id group by ca.category_id order by ca.category_id desc"
#        user = User.objects.get(username='dankram')
#        cur.execute(sql)
#        for r in cur:
#            print str(r[0])
#            if r[1] == '0':
#                try:
#                    comic = Comic.objects.get(title=r[6])
#                    comic.enable_forums = True
#                    comic.save()
#                except:
#                    continue
#                forum = Forum.objects.get_or_create(old_id=int(r[0]))
#                if created:
#                    print '  importing data'
#                    try:
#                        forum.user = comic.user
#                    except:
#                        continue
#                    forum.comic = comic
#                    forum.title = smart_str(r[2])
#                    forum.description = r[3]
#                    forum.order = int(r[4])
#                    forum.is_private = bool(int(r[5]))
#                    forum.save()
#            else:
#                category = int(r[1])
#                if category == 4 or category == 5:
#                    category = 1
#                forum, created = Forum.objects.get_or_create(old_id=int(r[0]))
#                if created:
#                    print '  importing data'
#                    forum.user = user
#                    forum.title = smart_str(r[2])
#                    forum.category = category
#                    forum.description = r[3]
#                    forum.order = int(r[4])
#                    forum.is_private = bool(int(r[5]))
#                    forum.save()
#        cur.close()
    
    def import_topics(self):
        
        for forum in Forum.objects.filter(comic__isnull=False).order_by('-id'):
            print str(forum.id)
            cur = self.get_forums_cursor()
            sql = "select t.topic_id as id, t.topic_name as title, sticky as is_sticky, if(t.flags & 16, 1, 0) as is_important, from_unixtime(date_created) as date_added, u.username, if(t.flags & 8, 1, 0) as is_locked, category_id from community_topics t left join drunkduck.users u on u.user_id = t.user_id where t.category_id = '%s' and u.username is not null and t.topic_name is not null order by t.topic_id desc" % str(forum.old_id)
            cur.execute(sql)
            for r in cur:
                try:
                    user = User.objects.get(username=r[5])
                except:
                    continue
                topic, created = Topic.objects.get_or_create(forum=forum, old_id=int(r[0]))
                if created:
                    print "  %s" % str(r[0])  
                    topic.user = user
                    topic.title = smart_str(r[1])
                    topic.is_sticky = bool(int(r[2]))
                    topic.is_important = bool(int(r[3]))
                    topic.is_locked = bool(int(r[6]))
                    topic.date_added = r[4]
                    topic.save() 
            cur.close()
    
    def import_posts(self):
        
        for topic in Topic.objects.filter(forum__comic__isnull=False).order_by('-id'):
            print str(topic.id)
            cur = self.get_forums_cursor()
            sql = "select p.post_body as body, from_unixtime(date_created) as date_added, u.username, p.topic_id, p.post_id from community_posts p left join drunkduck.users u on u.user_id = p.user_id where p.topic_id = '%s' and u.username is not null and p.post_body is not null order by post_id desc" % str(topic.old_id)
            cur.execute(sql)
            for r in cur:
                try:
                    user = User.objects.get(username=r[2])
                except:
                    continue
                post, created = Post.objects.get_or_create(topic=topic, old_id=int(r[4]))
                if created:
                    post.body = smart_str(r[0])
                    post.user = user
                    post.date_added = r[1]
                    post.save() 
            cur.close()
        
    def import_friends(self):
        
        print
        print 'IMPORTING FRIENDS...'
        print
        for request in Request.objects.filter(request_type=0).order_by('-id'):
            user1 = request.user
            user2 = request.content_object
            change_relationship_status(user1, user2, 2)
            print "%s: %s - %s" % (request.id, user1.username, user2.username)
            request.delete()
#        cur = self.get_cursor()
#        sql = "select u1.username, u2.username from friends f left join users u1 on f.user_id = u1.user_id left join users u2 on f.friend_id = u2.user_id where u1.username is not null and u2.username is not null order by u1.username, u2.username"
#        cur.execute(sql)
#        array = []
#        for r in cur:
#            try:
#                user1 = User.objects.get(username=r[0])
#                user2 = User.objects.get(username=r[1])
#            except:
#                continue
#            set = [user1.username, user2.username]
#            if set in array:
#                continue
#            print set
#            set.reverse()
#            if set in array:
#                print '  adding as friends'
#                change_relationship_status(user1, user2, 2)
#                array.remove(set)
#            else:
#                print '  adding to array'
#                set.reverse()
#                array.append(set)
#        cur.close()
#        print
#        print 'MAKING REQUESTS FROM LEFT OVER ARRAY...'
#        for item in array:
#            print item
#            user1 = User.objects.get(username=item[0])
#            user2 = User.objects.get(username=item[1])
#            change_relationship_status(user1, user2, 1)
#            Request.objects.create(user=user2, request_type=0, content_object=user1)
        
    def import_users(self):
        
        print
        print 'IMPORTING USERS...'
        print
        cur = self.get_cursor()
        sql = "select ifnull(first_name, ''), ifnull(last_name, ''), country, state, zipcode, ifnull(email, ''), gender, from_unixtime(dob_timestamp), u.username, u.password, from_unixtime(last_seen), from_unixtime(signed_up), ifnull(ip, '0.0.0.0'), avatar_ext, signature, about_self, if(flags & 2, 1, 0) as verified, if(flags & 4096, 1, 0) as banned, u.user_id, u.trophy_string from users u left join demographics d on d.user_id = u.user_id where u.username is not null and (~flags & 4096 = 4096) order by username asc"
        cur.execute(sql)
        for r in cur:
            print r[8]
            user, created = User.objects.get_or_create(username=r[8])
            if created:
                print '  importing data'
                user.first_name = r[0]
                user.last_name = r[1]
                if (r[5].count('') - 1) < 75:
                    user.email = r[5]
                user.set_password(r[9])
                user.date_joined = r[11]
                user.last_login = r[10]
                user.save()
                profile, created = Profile.objects.get_or_create(user=user)
                profile.country = r[2]
                profile.state = r[3]
                try:
                    profile.zip = int(r[4][:5])
                except:
                    pass
                profile.gender = r[6]
                profile.birthday = r[7]
                profile.ip_address = r[12]
                profile.bio = r[15]
                profile.verified = bool(int(r[16]))
                profile.old_user_id = r[18]
                profile.banned = bool(int(r[17]))
                if r[19]:
                    profile.trophy_string = r[19]
                if r[13]:
                    path = "users/%s/thumb/avatar.%s" % (r[8], r[13])
                    if os.path.exists('media/' + path):
                        profile.avatar = path
                    else:
                        profile.avatar = None 
                else:
                    profile.avatar = None
                profile.save()
                if r[14]:
                    signature, created = Signature.objects.get_or_create(user=user)
                    if created:
                        signature.body = smart_str(r[14])
                        signature.save()
        cur.close()
        
    def import_profile_comments(self):
        
        print
        print 'IMPORTING PROFILE COMMENTS...'
        print
        for profile in Profile.objects.order_by('user__username'):
            profile.comments.all().delete()
            print profile.user.username
            print '  importing comments'
            cur = self.get_cursor()
            sql = "select u.username as author, from_unixtime(c.posted) as date_added, c.comment as body from profile_comments c left join users u on u.user_id = c.poster_id where approved = 1 and c.user_id = '%s' and u.username is not null and c.comment is not null and ltrim(rtrim(c.comment)) != '' order by u.username" % str(profile.old_user_id) 
            cur.execute(sql)
            for r in cur:
                try:
                    user = User.objects.get(username=r[0])
                except:
                    continue
                comment = Comment.objects.create(author=user, body=r[2])
                comment.date_added = r[1]
                comment.save()
                profile.comments.add(comment)
                print '      comment added: ' + user.username
            cur.close()
    
    def import_comics(self):
        
        print
        print 'IMPORTING COMICS...'
        print
        
        for comic in Comic.live.all().order_by('-id'):
            print comic.id
            if comic.pages.count() == 0:
                comic.date_modified = None
                comic.save()
                print '  fixed'
            
#        cur = self.get_cursor()
#        sql = "select u1.username as user, c.comic_name as title, if(c.flags & 16, 1, 0) as frozen, from_unixtime(last_update) as date_modified, c.comic_type as type, c.category as genre, c.subcategory as tone, c.search_style as style, ifnull(c.description, '') as description, u2.username as assistant, from_unixtime(c.created_timestamp) as date_added, c.seven_day_visits, c.writer_name, c.illustrator_name, c.editor_name, c.rating_symbol as rating from comics c left join users u1 on u1.user_id = c.user_id left join users u2 on u2.user_id = c.secondary_author where c.comic_name is not null order by c.comic_name"
#        cur.execute(sql)
#        for r in cur:
#            print r[1]
#            try:
#                user = User.objects.get(username=r[0])
#            except:
#                continue
#            slug = r[1].replace(' ', '_')
#            comic, created = Comic.objects.get_or_create(title=r[1])
#            if created:
#                print '  importing data'
#                comic.slug = slug
#                comic.frozen = r[2]
#                comic.type = r[4]
#                comic.genre = r[5]
#                comic.tone = r[6]
#                comic.style = r[7]
#                comic.description = r[8]
#                comic.date_added = r[10]
#                comic.seven_day_visits = r[11]
#                comic.rating = r[15] 
#                comic.user = user
#                path = 'users/' + user.username + '/comics/' + slug + '/thumb/thumb.jpg'
#                if os.path.exists('media/' + path):
#                    comic.thumbnail = path
#                else:
#                    comic.thumbnail = None
#                comic.save()
#                if r[9]:
#                    try:
#                        assistant = User.objects.get(username=r[9])
#                        comic.assistants.add(assistant)
#                    except:
#                        pass
#                if r[12]:
#                    credit = ComicCredit.objects.create(comic=comic, name=r[12], credit='writer')
#                if r[13]:
#                    credit = ComicCredit.objects.create(comic=comic, name=r[13], credit='illustrator')
#                if r[14]:
#                    credit = ComicCredit.objects.create(comic=comic, name=r[14], credit='editor')
#        cur.close()

    def import_credits(self):
        
        print
        print 'IMPORTING CREDITS...'
        print
        for comic in Comic.objects.all():
            cur = self.get_cursor()
            sql = "select c.comic_name, cr.credit_name, cr.credit_value from credits cr left join comics c on c.comic_id = cr.comic_id where c.comic_name = '" + comic.title + "' order by cr.credit_name"
            cur.execute(sql)
            print comic.title
            for r in cur:
                try:
                    credit, created = ComicCredit.objects.get_or_create(comic=comic, name=r[2], credit=smart_str(r[1]))
                except:
                    continue
                if created:
                    print '  ' + smart_str(r[1]) 
            cur.close()
    
    def import_favorites(self):
        
        print
        print 'IMPORTING FAVORITES, RECOMMENDS AND EMAIL ALERTS...'
        print
        for comic in Comic.objects.all():
            cur = self.get_cursor()
            sql = "select u.username, c.comic_name, f.email_on_update, f.recommend from comic_favs f left join users u on u.user_id = f.user_id left join comics c on c.comic_id = f.comic_id where c.comic_name = '" + comic.title + "' order by u.username"
            cur.execute(sql)
            print comic.title
            for r in cur:
                user = User.objects.filter(username=r[0])
                if user:
                    user = user[0]
                    print '  ' + user.username
                    if user not in comic.favorites.all():
                        comic.favorites.add(user)
                        print '    added favorite'
                    if int(r[2]):
                        if user not in comic.email_alerts.all():
                            comic.email_alerts.add(user)
                            print '    added email alerts'
                    if int(r[3]):
                        if user not in comic.recommends.all():
                            comic.recommends.add(user)
                            print '    added recommendations'
            cur.close()
    
    def import_pages(self):
    
        print
        print 'IMPORTING COMIC PAGES...'
        print
        for page in ComicPage.objects.exclude(content__icontains='jpg').order_by('title'):
            filename, ext = str(page.content).split('.')
            page.content = filename + '.jpg'
            page.save()
            print smart_str(page.title)
            
#        for comic in Comic.objects.order_by('title'):
#            cur = self.get_cursor()
#            print comic.title
#            sql = "select from_unixtime(post_date), order_id, page_title, ifnull(p.comment, ''), file_ext, is_chapter, p.page_id, c.comic_id, c.comic_name from comic_pages p left join comics c on c.comic_id = p.comic_id where order_id is not null"
#            cur.execute(sql)
#            for r in cur:
#                page, created = ComicPage.objects.get_or_create(comic=comic, old_page_id=int(r[6]))
#                if created:
#                    title = smart_str(r[2])
#                    print '  ' + title
#                    print '    importing data'
#                    page.title = title
#                    page.post_date = r[0]
#                    page.order_id = int(r[1])
#                    page.comment = r[3]
#                    path = "users/%s/comics/%s/web/%s.%s" % (comic.user.username, comic.slug, str(r[6]).zfill(8), r[4])
#                    if os.path.exists('media/' + path):
#                        page.content = path
#                    else:
#                        page.content = None 
#                    page.is_chapter = bool(int(r[5]))
#                    page.save()
#            cur.close()
    
    def import_page_comments(self):
        
        print
        print 'IMPORTING PAGE COMMENTS...'
        print
        for page in ComicPage.objects.order_by('title'):
            page.comments.all().delete()
            print smart_str(page.title)
            print '  importing comments'
            cur = self.get_cursor()
            sql = "select u.username as author, from_unixtime(co.post_date) as date_added, co.comment as body, if(co.flags & 1, 1, 0) as is_anonymous from page_comments co left join users u on u.user_id = co.user_id where co.page_id = '" + str(page.old_page_id) + "' and u.username is not null and (~co.flags & 16 = 16) and co.comment is not null and ltrim(rtrim(co.comment)) != '' order by u.username" 
            cur.execute(sql)
            for r in cur:
                try:
                    user = User.objects.get(username=r[0])
                except:
                    continue
                comment = Comment.objects.create(author=user, body=r[2], is_anonymous=bool(r[3]))
                comment.date_added = r[1]
                comment.save()
                page.comments.add(comment)
                print '      comment added: ' + user.username
            cur.close()
    
    def import_news(self):
        
        print
        print 'IMPORTING NEWS...'
        print
        print 'REMOVING OLD NEWS...'
        print
        Article.objects.all().delete()
        cur = self.get_cursor()
        sql = "select b.title, b.body, from_unixtime(b.timestamp_date), from_unixtime(b.edit_timestamp), u.username from admin_blog b left join users u on b.user_id = u.user_id where b.title is not null and b.body is not null and u.username is not null and ltrim(rtrim(b.title)) != '' and ltrim(rtrim(b.body)) != '' order by b.title"
        cur.execute(sql)
        for r in cur:
            user = User.objects.filter(username=r[4])
            if user:
                user = user[0]
                article = Article.objects.create(title=r[0], body=r[1], is_live=True, author=user, date_live=r[2])
                article.date_added = r[2]
                article.save()
                print r[0]
                print '  importing data'
        cur.close()
    
    def import_comics_featured(self):
        
        print
        print 'IMPORTING FEATURED COMICS...'
        print
        cur = self.get_cursor()
        for comic in Comic.objects.order_by('title'):
            sql = "select f.description, concat(substring(f.ymd_date_live, 1, 4), '-', substring(f.ymd_date_live, 5, 2), '-', substring(f.ymd_date_live, 7, 2), ' 00:00:00') as date_featured, f.feature_id from featured_comics f left join comics c on c.comic_id = f.comic_id where c.comic_name = '" + comic.title + "' and f.description is not null and ltrim(rtrim(f.description)) != '' order by c.comic_name"
            cur.execute(sql)
            for r in cur:
                print comic.title
                print '  importing data'
                feature, created = FeaturedComic.objects.get_or_create(comic=comic)
                feature.description = smart_str(r[0])
                path = 'features/' + comic.title.replace(' ', '_') + '/thumb/featured.jpg'
                if os.path.exists('media/' + path):
                    feature.thumbnail = path
                else:
                    feature.thumbnail = None
                feature.date_featured = r[1]
                feature.save()
        cur.close()
        
if __name__ == "__main__":
    
    suite = Suite()
    try:
        suite.begin()
    except:
        traceback.print_exc()
        suite.close()
        if settings.hostname == 'drunkduck':
            msg = """The import failed with the following error: \n\n\n %s. arguments: %s""" % (traceback.format_exc(),', '.join(sys.argv))
            send_mail('Import error', msg, 'support@drunkduck.com', ['lleach@wowio.com', 'danielkram@gmail.com'])
