#!/usr/bin/env python
from django.core.management import setup_environ
import settings
setup_environ(settings)


from comics.models import *


def main(option, option2=None):
    comics = Comic.objects.all()
    comics_featured = FeaturedComic.objects.all()
    comic_pages = ComicPage.objects.all()
    comic_layouts = ComicLayout.objects.all()

    if option == 'comics':
        for comic in comics:
            if comic.thumbnail:
                thumb_list = str(comic.thumbnail).split('/')
                if not thumb_list[0] == 'comics':
                    comic.thumbnail = 'comics/' + '/'.join(thumb_list)
                    comic.save()
                    print comic.thumbnail
                else:
                    print "NOT***", comic.thumbnail


    if option == 'featured':
        for featured in comics_featured:
            if featured.thumbnail:
                thumb_list = str(featured.thumbnail).split('/')
                if not thumb_list[0] == 'comics':
                    featured.thumbnail = 'comics/' + '/'.join(thumb_list)
                    if not option2 == 'reverse':
                        featured.save()
                    print featured.thumbnail
                else:
                    if option2 == 'reverse':
                        del thumb_list[0]
                        featured.thumbnail = '/'.join(thumb_list)
                        featured.save()
                    print "NOT***", featured.thumbnail

    if option == 'pages':
        for page in comic_pages:
            if page.content:
                page_list = str(page.content).split('/')
                if not page_list[0] == 'comics':
                    page.content = 'comics/' + '/'.join(page_list)
                    page.save()
                    print page.content
                else:
                    print "NOT***", page.content


    if option == 'layouts':
        for layout in comic_layouts:
            changed = False
            if layout.background_image:
                bg_list = str(layout.background_image).split('/')
                if not bg_list[0] == 'comics':
                    layout.background_image = 'comics/' + '/'.join(bg_list)
                    changed = True
                    print layout.background_image
                else:
                    print "NOT***", layout.background_image

            if layout.header_image:
                header_list = str(layout.header_image).split('/')
                if not header_list[0] == 'comics':
                    layout.header_image = 'comics/' + '/'.join(header_list)
                    changed = True
                    print layout.header_image
                else:
                    print "NOT***", layout.header_image

            if layout.arrow_first:
                first_list = str(layout.arrow_first).split('/')
                if not first_list[0] == 'comics':
                    layout.arrow_first = 'comics/' + '/'.join(first_list)
                    changed = True
                    print layout.arrow_first
                else:
                    print "NOT***", layout.arrow_first

            if layout.arrow_prev:
                prev_list = str(layout.arrow_prev).split('/')
                if not prev_list[0] == 'comics':
                    layout.arrow_prev = 'comics/' + '/'.join(prev_list)
                    changed = True
                    print layout.arrow_prev
                else:
                    print "NOT***", layout.arrow_prev
    
            if layout.arrow_next:
                next_list = str(layout.arrow_next).split('/')
                if not next_list[0] == 'comics':
                    layout.arrow_next = 'comics/' + '/'.join(next_list)
                    changed = True
                    print layout.arrow_next
                else:
                    print "NOT***", layout.arrow_next

            if layout.arrow_last:
                last_list = str(layout.arrow_last).split('/')
                if not last_list[0] == 'comics':
                    layout.arrow_last = 'comics/' + '/'.join(last_list)
                    changed = True
                    print layout.arrow_last
                else:
                    print "NOT***", layout.arrow_last

            if changed:
                layout.save()


if __name__ == '__main__':
    import sys
    option = sys.argv[1]
    option2 = sys.argv[2]
    main(option, option2)
