from django.contrib import admin
from news.models import *

class ArticleAdmin(admin.ModelAdmin):
    list_display = ('title','date_added','is_live','urgent',)
    search_fields = ['title', 'body']
    list_filter = ('date_added', 'is_live','urgent')
    prepopulated_fields = {"slug" : ('title',)}
    exclude = ('author', 'comments', 'likes',)
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.author:
            instance.author = request.user
        instance.save()
        return instance

admin.site.register(Article, ArticleAdmin)