from django import template
from postmarkup import render_bbcode
from django.utils.safestring import mark_safe
from xml.sax.saxutils import unescape
from django.utils.encoding import smart_str
from django.utils.html import strip_tags
import re

register = template.Library()

@register.filter
def tags(tagged_object):

    tags = tagged_object.tags.replace(',','')
    return tags.split(' ')

@register.filter
def get_line_height(n):
    
    try:
        n = int(n * 1.5)
    except:
        return 18
    return n

@register.filter
def bbcode2html(string):
    string = strip_tags(smart_str(string))
    # I had to unescape the html because
    # unescaped html exists in the database
    # for some reason.
    p = re.compile('\[\/?size=?\d*?\]')
    matches = p.findall(string)
    if matches:
        for match in matches:
            string = string.replace(match, '')
    p = re.compile('http:/[a-zA-Z\d]')
    matches = p.findall(string)
    if matches:
        for match in matches:
            string = string.replace(match, 'http://')
    p = re.compile('\[spoiler=?[a-zA-Z\s!\.]*\]')
    matches = p.findall(string)
    p = re.compile('\[\/spoiler\]')
    end_matches = p.findall(string)
    if matches and end_matches:
        for match in matches:
            string = string.replace(match, '<span class="spoiler">')
        for match in end_matches:
            string = string.replace(match, '</span>')
    html = render_bbcode(string)
    p = re.compile('\[.*?\.com\]')
    matches = p.findall(html)
    if matches:
        for match in matches:
            html = html.replace(match, '')
    unescaped_html = unescape(html)
    return mark_safe(unescaped_html)

bbcode2html.is_safe = True