from django.shortcuts import render_to_response, get_object_or_404, render
from django.template import RequestContext
from news.models import *
from datetime import datetime

def news(request):
    
    articles = Article.objects.filter(is_live=True, date_live__lte=datetime.now()).order_by('-date_live')
    if 'search' in request.GET:
        search = request.GET['search'].strip()
        if search != 'search news':
            articles = articles.filter(title__icontains=search) | articles.filter(body__icontains=search) | articles.filter(author__username__icontains=search) | articles.filter(tags__icontains=search)
    variables = {
        'articles': articles,
    }
    return render(request, 'news/list.html', variables)

def display(request, id):
    
    article = get_object_or_404(Article, id=id, is_live=True, date_live__lte=datetime.now())
    return render_to_response('news/display.html', {'article':article}, context_instance=RequestContext(request))