from django.contrib import admin
from django.template.defaultfilters import slugify
from podcasts.models import *

class EpisodeAdmin(admin.ModelAdmin):

    prepopulated_fields = {"slug" : ('title',)}
    search_fields = ['title']
    list_display = ('title', 'is_live', 'date_added',)
    list_filter = ('date_added', 'is_live',)
    exclude = ('comments','likes','user',)
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.user:
            instance.user = request.user
        instance.slug = slugify(instance.title)
        instance.save()
        return instance
    
admin.site.register(Episode, EpisodeAdmin)
