from django.shortcuts import render_to_response, get_object_or_404
from django.template import RequestContext
from podcasts.models import *
from datetime import datetime

def list(request):

    search = False
    date = False
    episodes = Episode.live.all()
    
    if 'search' in request.GET:
        search = request.GET['search'].strip()
        if search != 'search episodes':
            episodes = episodes.filter(title__icontains=search) | episodes.filter(summary__icontains=search) | episodes.filter(notes__icontains=search) | episodes.filter(tags__icontains=search)
    
    variables = {
        'episodes':episodes,
        'search': search,
        'date': date,
        'view': 'quackcast',
    }
    
    return render_to_response('podcasts/list.html', variables, context_instance=RequestContext(request))
    
def display(request, slug):
    
    episode = get_object_or_404(Episode, slug=slug, is_live=True, date_live__lte=datetime.now())
    return render_to_response('podcasts/display.html', {'episode': episode, 'view':'quackcast'},  context_instance=RequestContext(request))    
