import numpy
from django import template
from django.contrib.auth.models import User

register = template.Library()

@register.filter
def get_object_type(object):
    
    return type(object).__name__.lower()

@register.filter
def get_rating(object):
    
    ratings = [rating.rating for rating in object.ratings.all()]
    average = numpy.average(ratings)
    try:
        average = int(average)
    except:
        return 0
    return average

@register.filter
def get_user_rating(object, user):
    
    try:
        user = User.objects.get(username=user.username)
    except:
        return 0
    ratings = [rating.rating for rating in object.ratings.filter(user=user)]
    average = numpy.average(ratings)
    try:
        average = int(average)
    except:
        return 0
    return average

@register.filter
def get_vote_count(object):
    
    return object.ratings.count()

@register.filter
def get_range(n):
    
    return xrange(n)

@register.filter
def like_button_suffix(object, user):
    
    like = object.likes.filter(user=user)
    if like:
        return 'liked'
    return 'like'
