from django.db import models
from django.contrib.contenttypes.models import ContentType
from django.contrib.contenttypes import generic
from django.contrib.auth.models import User

REQUEST_TYPES = (
    (0, 'friend'),
    (1, 'assistant'),
)

# Create your models here.
class Request(models.Model):

    user = models.ForeignKey(User, related_name='requests')
    request_type = models.IntegerField(choices=REQUEST_TYPES, null=True)
    
    # generic relationships
    content_type = models.ForeignKey(ContentType)
    object_id = models.PositiveIntegerField()
    content_object = generic.GenericForeignKey('content_type', 'object_id')