from django.db import models
from django.contrib.auth.models import User

class Trophy(models.Model):
    
    name = models.CharField(max_length=200)
    description = models.TextField(null=True, blank=True)
    thumbnail = models.ImageField(upload_to='uploads', null=True, blank=True)
    users = models.ManyToManyField(User, related_name='trophies', null=True, blank=True)
    
    def __unicode__(self):
        
        return self.name
    
    class Meta:
        
        verbose_name = 'Trophy'
        verbose_name_plural = 'Trophies'