from django.contrib import admin
from tutorials.models import *
from tinymce.widgets import TinyMCE
from django.forms import Textarea
from tutorials.forms import *

class TutorialAdmin(admin.ModelAdmin):
    
    list_display = ('user', 'title',)
    exclude = ('user','comments','ratings',)
    search_fields = ['user__username', 'title']
#    form = TutorialForm
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.user:
            instance.user = request.user
        instance.save()
        return instance

admin.site.register(Tutorial, TutorialAdmin)

class FeaturedTutorialAdmin(admin.ModelAdmin):
    
    list_display = ('tutorial',)
    search_fields = ['tutorial__title']
    
admin.site.register(FeaturedTutorial, FeaturedTutorialAdmin)