from django.contrib.auth.models import User
from django.db import models
from comments.models import Comment
from tagging.fields import TagField
from ratings.models import *

class Tutorial(models.Model):
    
    user = models.ForeignKey(User, related_name='tutorials', null=True, blank=True)
    is_deleted = models.BooleanField(default=False)
    date_added = models.DateTimeField(auto_now_add=True)
    date_modified = models.DateTimeField(auto_now=True)
    title = models.CharField(max_length=200)
    description = models.TextField()
    body = models.TextField()
    comments = models.ManyToManyField(Comment, null=True, blank=True)
    ratings = models.ManyToManyField(Rating, null=True, blank=True)
    tags = TagField()
    
    def __unicode__(self):
        
        return self.title
    
class FeaturedTutorial(models.Model):
    
    tutorial = models.OneToOneField(Tutorial)
    thumbnail = models.ImageField(upload_to='uploads', blank=True, null=True)
    description = models.TextField()
    
    class Meta:
        
        verbose_name = 'Featured Tutorial'
        verbose_name_plural = 'Featured Tutorials'
