from django.db import models
from django.conf import settings
import tweepy


class Tweet(models.Model):
    text = models.TextField()
    date_pulled = models.DateTimeField(auto_now_add=True)


def update_tweets():
    auth = tweepy.OAuthHandler(settings.CONSUMER_KEY, settings.CONSUMER_SECRET)
    auth.set_access_token(settings.ACCESS_TOKEN, settings.ACCESS_SECRET)
    api = tweepy.API(auth)

    dd_tweets = tweepy.api.user_timeline('drunkduck')
    dd_tweets.reverse()
    for tweet in dd_tweets:
        t = Tweet.objects.filter(text=tweet.text)
        if not t:
            Tweet.objects.create(text=tweet.text)
