import os
from django.conf.urls.defaults import *
from django.contrib import admin
from views import *
from comics.views import *
from subpages.views import display_subpage
from comics.feeds import *
from corp.views import *
from api.views import *
from django.views.generic.simple import direct_to_template

admin.autodiscover()

urlpatterns = patterns('',
    (r'^$', home_page),
    (r'^login/$', do_login),
    (r'^logout/$', user_logout),

    #ads
    (r'^ads/728x90/$', direct_to_template, {'template': 'ads/728x90.html'}),
    
    #ajax
    (r'^ajax/side-panel/comics-list/$', comics_list),
    (r'^ajax/side-panel/favorites-list/$', favorites_list),
    (r'^ajax/ten-list/(?P<type>.*)/$', ten_list),
    
    #errors
    (r'^errors/age/$', direct_to_template, {'template': 'errors/age.html'}),
    (r'^errors/nopages/$', direct_to_template, {'template': 'errors/nopages.html'}),
    
    # corporate
    (r'^privacy/$', privacy),
    (r'^about/$', about),
    (r'^terms/$', terms),
    (r'^etiquette/$', etiquette),
    (r'^copyright/$', copyright),
    (r'^help/$', help),

    # api
    (r'^api/latestnews/$', api_latestnews),
    (r'^api/featuredcomics/$', api_featuredcomics),
    (r'^api/toptencomics/$', api_toptencomics),
    (r'^api/quackcast/$', api_quackcastepisodes),
    
    # Uncomment the admin/doc line below and add 'django.contrib.admindocs' 
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    (r'^admin/', include(admin.site.urls)),
    # (r'^tagging_autocomplete/', include('tagging_autocomplete.urls')),
    
    # views
    (r'^user/video/',include('uservideos.urls')),
    (r'^user/', include('users.urls')),
    (r'^video/',include('videos.urls')),
    (r'^news/',include('news.urls')),
    (r'^quack/', include('messages.urls')),
    (r'^quackcast/', include('podcasts.urls')),
    (r'^tutorial/',include('tutorials.urls')),
    (r'^community/',include('forums.urls')),
    (r'^forum/',include('forums.urls')),
    (r'^comics/', include('comics.urls')),
    (r'^search/', include('search.urls')),
    (r'^comments/', include('comments.urls')),
    (r'^duckmarks/', include('duckmarks.urls')),
    (r'^ratings/', include('ratings.urls')),
    (r'^requests/', include('requests.urls')),
    (r'^analytics/', include('analytics.urls')),
    (r'^imagelocker/', include('imagelocker.urls')),
    (r'^layout/', include('layouts.urls')),
    (r'^subpages/', include('subpages.urls')),
    
    (r'^(?P<slug>[-\w]+)/rss/$', ComicFeed()),
    (r'^(?P<slug>[-\w]+)/(?P<page_id>\d+)/$',comic_page),
    (r'^(?P<comic_slug>[-\w]+)/(?P<subpage_slug>[-\w]+)/$', display_subpage),
    (r'^(?P<slug>[-\w]+)/$',comic_page),
    (r'^tinymce/', include('tinymce.urls'))
)

import settings
if settings.DEBUG:
    urlpatterns += patterns('',
        (r'^media/(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT})
    )
