from django.core.management import setup_environ
import settings
setup_environ(settings)

from comics.models import *
#from comicpages.models import *
#from django.contrib.auth.models import User
#from users.models import *
#from datetime import datetime
import csv
import hashlib
from django.utils.encoding import smart_str


def read_csv():
    print 'Opening Files...'
    pages_reader = csv.DictReader(open('comic_page_export.csv', 'r'), delimiter=',', quotechar='"')

    print 'Importing Comic Pages...'
    ComicPage.objects.all().delete()
    for old_page in pages_reader:
        old_page_id = int(old_page['p.old_page_id'])
        if old_page_id in [451660, 744184]:
            continue
        try:
            comic = Comic.objects.get(title=smart_str(old_page['c.comic_name']))
        except:
            continue
        date, time = old_page['post_date'].split(' ')
        month, day, year = date.split('/')
        post_date = "%s-%s-%s %s" % (year, month, day, time)
        path = "users/%s/comics/%s/web/%s.jpg" % (comic.user.username, comic.slug, str(old_page_id).zfill(8))
        page = ComicPage.objects.create(
            comic=comic,
            post_date=smart_str(post_date),
            title=smart_str(old_page['p.title']),
            is_chapter=bool(int(old_page['p.is_chapter'])),
            comment=smart_str(old_page['comment']),
            old_page_id=int(old_page['p.old_page_id']),
            order_id=int(old_page['p.order_id']),
            file_ext=smart_str(old_page['p.file_ext']),
            content=path
        )
        print "%s (%s)" % (smart_str(page.title), str(page.old_page_id))
    print 'DONE'

if __name__ == '__main__':
    read_csv()