from django import template
from datetime import date
from settings import MEDIA_URL

register = template.Library()

@register.filter
def is_mature(user):
    if user.is_authenticated():
        try:
            birthday = user.profile.birthday
            diff = date.today() - birthday
        except:
            return False
        age = diff.days / 365
        if age >= 18:
            return True
    return False

@register.filter
def can_see_comic(user, comic):
    if comic.rating == 'A':
        return is_mature(user)
    return True

@register.filter
def avatar(user, anonymous=False):
    url = MEDIA_URL + 'images/avatar-generic-duck.png'
    if anonymous:
        return url
    try:
        return user.profile.avatar.url
    except:
        return url

@register.filter
def trophies(profile):
    
     return profile.trophy_string.split(',')

@register.filter
def get_favorites(user):
    
    return user.favorite_comics.filter(is_deleted=False)

@register.filter
def get_comics(user):
    
    return user.comics.filter(is_deleted=False)