import re
from django import forms
from uservideos.models import *
from oembed.models import ProviderRule

class UserVideoForm(forms.ModelForm):
    
    class Meta:
        model = UserVideo
        exclude = ('user', 'embed',)
        
    def clean_url(self):
        
        url = self.data['url']
        for rule in ProviderRule.objects.all():
            if re.match(rule.regex, url):
                return url
        raise forms.ValidationError('Not a valid video URL.')