from django.db import models
from django.contrib.auth.models import User

class UserVideo(models.Model):
    
    user = models.ForeignKey(User, related_name='videos')
    is_deleted = models.BooleanField(default=False)
    url = models.URLField()
    embed = models.TextField(null=True, blank=True)
    title = models.CharField(max_length=255)
    description = models.TextField()
    date_added = models.DateTimeField(auto_now_add=True, blank=True)
    
    def __unicode__(self):
        
        return self.user.username + ' - ' + str(self.date_added) 
    
    class Meta:
        
        verbose_name = 'User Video'
        verbose_name_plural = 'User Videos'
        ordering = ('-date_added',)