from django.contrib.auth.models import User
from django.http import HttpResponseRedirect
from django.shortcuts import render_to_response, get_object_or_404
from django.template import RequestContext
from uservideos.models import *
from uservideos.forms import *

def remove(request, id):
    
    video = get_object_or_404(UserVideo, pk=id)
    if  video.user == request.user:
        video.is_deleted = True
        video.save()
    return HttpResponseRedirect('/user/#videos')

def add(request):
    
    if request.method == 'POST':
        form = UserVideoForm(request.POST)
        if form.is_valid():
            video = form.save(commit=False)
            video.user = request.user
            video.save()
            return HttpResponseRedirect('/user/#videos')
    else:
        form = UserVideoForm()
    return render_to_response('uservideos/add.html', {'form': form}, context_instance=RequestContext(request))