from django.contrib import admin
from videos.models import *

class VideoAdmin(admin.ModelAdmin):
    
    list_display = ('title', 'subtitle', 'pub_date', 'is_live', 'is_featured', 'is_in_carousel', 'wowio', 'wevolt', 'syndicate')
    exclude = ('comments','user','likes',)
    
    def save_model(self, request, instance, form, change):
        
        instance = form.save(commit=False)
        if not instance.user:
            instance.user = request.user
        instance.save()
        return instance

admin.site.register(Video, VideoAdmin)