from django.shortcuts import render_to_response, get_object_or_404
from django.template import RequestContext
from videos.models import *

def display(request, slug):
    
    video = get_object_or_404(Video, slug=slug)
    return render_to_response('videos/display.html', {'video':video}, context_instance=RequestContext(request))    

def list(request):
    
    videos = Video.objects.filter(is_live=True).order_by("-pub_date")
    variables = {}
    if videos:
#        latest_video = videos[0]
#        videos = videos[1:]
        latest_video = False
        variables = {'videos':videos, 
                     'latest_video':latest_video}
    return render_to_response('videos/list.html', variables, context_instance=RequestContext(request))
